// Copyright (C) 1998 Logi Ragnarsson

package is.hi.logir.cryptonite;

/**
 * Ancestor of EncryptedKeyEx classes.
 *
 * @author <a href="http://www.hi.is/~logir/">Logi Ragnarsson</a>
 * (<a href="mailto:logir@hi.is">logir@hi.is</a>) */
class EncryptedKeyEx extends Cryptonite {
  
  protected boolean keyDecided=false;
  protected CipherKey key;
  protected Key sessionKey;
  
  /**
   * Called from sub-classes. Use The Source.
   */
  public EncryptedKeyEx(CipherKey key, Key sessionKey){
    this.key=key;
    this.sessionKey=sessionKey;    
  }

  /**
   * Returns the key if it has been decided upon,
   * or <code>null</code> otherwise.
   */
  public Key sessionKey(){
    return keyDecided ? sessionKey : null;
  }
  
}
