// Copyright (C) 1998 Logi Ragnarsson

package is.hi.logir.cryptonite;

/**
 * Receive an encrypted key from the correstponding EncryptedKeyExClient
 *
 * @see is.hi.logir.cryptonite.EncryptedKeyExClient
 *
 * @author <a href="http://www.hi.is/~logir/">Logi Ragnarsson</a>
 * (<a href="mailto:logir@hi.is">logir@hi.is</a>)
 */
public class EncryptedKeyExServer extends EncryptedKeyEx implements NoninterKeyExServer {

  /**
   */
  public EncryptedKeyExServer(CipherKey key){
    super(key,null);
  }

  /**
   * Rceive a message from the client.
   *
   * @exception ProtocolException if a malformed message is received
   */
  public byte[] message(byte[] received) throws ProtocolException {
    if(received==null)
      throw new ProtocolException("null message received");

    DecryptMode dm=new DecryptECB(key);
    int pl=(int)makeLong(received,0,4);
    byte[] p1=dm.decrypt(received,4,received.length-4);
    byte[] plain;
    if(pl==p1.length)
      plain=p1;
    else {
      plain=new byte[pl];
      System.arraycopy(p1,0, plain,0, pl);
    }
    try{
        sessionKey = (Key)fromString(new String(plain));
      keyDecided=true;
      return null;
    } catch (Exception e) {
    }
    throw new ProtocolException("Did not receive a valid cds for a CipherKey object.");
  }

}
