// Copyright (C) 1998 Logi Ragnarsson

package is.hi.logir.cryptonite;

/**
 * This class implements the client portion of the key-exchange
 * protocol whereby the client sends the server the hash of the key
 * that should be used for decryption. The server is assumed to have
 * this key in its default KeySource.
 *
 * @see is.hi.logir.cryptonite.SendHashKeyExchengeServer.
 *
 * @author <a href="http://www.hi.is/~logir/">Logi Ragnarsson</a>
 * (<a href="mailto:logir@hi.is">logir@hi.is</a>) */
public class SendHashKeyExClient extends SendHashKeyEx implements NoninterKeyExClient {

  /** Create a new SendHashKeyEx with the Key <code>k</code>. */
  public SendHashKeyExClient(Key k){
    super(k);
  }
  
  /**
   * Return the message to send to the server.
   *
   * @exception ProtocolException if a message is received
   */
  public byte[] message(byte[] received) throws ProtocolException {
    if(received!=null)
      throw new ProtocolException("A KeyExClient should never receive messages.");
    byte[] r=sessionKey.matchFingerprint().toString().getBytes();
    keyDecided=true;
    return r;
  }
  
}
