#include <stdio.h>
#include "gmp.h"

void precalc(int n, int sub){
    mpz_t m, h, g;
    fprintf(stderr,"n=%i\n",n);
    sub=4*(sub/4)+1;
    
    mpz_init(m);
    mpz_init(h);
    
    mpz_ui_pow_ui(m,2,n); 
    mpz_sub_ui(m,m,sub);
    while(!mpz_probab_prime_p(h, 2) || // 50 iterations on each... we'll be checking a LOT of numbers!
	  !mpz_probab_prime_p(m, 2) ||
          !mpz_probab_prime_p(h, 4) || // First check each briefly, then more thoroughly.
          !mpz_probab_prime_p(m, 4) || // h first, since it is smaller and quicker.
          !mpz_probab_prime_p(h, 8) ||
          !mpz_probab_prime_p(m, 8) ||
	  !mpz_probab_prime_p(h,16) ||
	  !mpz_probab_prime_p(m,16) ||
  	  !mpz_probab_prime_p(h,20) ||
          !mpz_probab_prime_p(m,20)){
	if((sub%100)<4)
	    fprintf(stderr,"%i        \r",sub-1);
	sub+=4;
	mpz_sub_ui(m,m,4);
        mpz_tdiv_q_ui(h,m,2);
    }
    
    fprintf(stderr,"m=");
    mpz_out_str (stderr, 16, m);
    fprintf(stderr,"\n =2^%i-%i\n\n",n,sub);
    mpz_clear(m);
    mpz_clear(h);
}

main (){
    precalc(256 ,  36100);   // Should be called with the second parameter 0
    precalc(512 ,  38100);   // unless you are re-checking previous calculations.
    precalc(1024,1093300);
    precalc(2048,1942200);
    printf("\a\a\aDONE!\a\a\a\n");
    exit (0);
}





